﻿Public Class Cell
    Public Status As CellStatus
    Public Grid As ReverseGrid
    Public Position As Point
    Public Rectangle As Rectangle
    Public Through As Boolean
    Public IamHead As Boolean
    Public HeadPos As Houkou

    Public Sub New(ByVal Grid As ReverseGrid, ByVal Position As Point)
        Me.Grid = Grid
        Me.Position = Position
        Me.Status = CellStatus.Nothing
        Me.Through = False
        Me.IamHead = False
        Me.HeadPos = Houkou.Down

        Dim Rect As New Rectangle

        Rect.X = Position.X * Grid.CellSize
        Rect.Y = Position.Y * Grid.CellSize
        Rect.Width = Grid.CellSize
        Rect.Height = Grid.CellSize
        Me.Rectangle = Rect
    End Sub

    Public Sub Draw(ByVal g As Graphics)
        Dim CellRect As Rectangle = Me.Rectangle
        Dim MyPen As New Pen(Color.FromArgb(70, 35, 25), CellRect.Width / 5)

        If through Then
            MyPen.Color = Color.ForestGreen
        End If
        Select Case Me.Status
            Case CellStatus.Nothing
                g.FillRectangle(Brushes.Khaki, CellRect.X + 1, CellRect.Y + 1, CellRect.Width - 2, CellRect.Height - 2)
            Case CellStatus.LeftRight
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Left)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Right)
                DrawHead(g, CellRect)
            Case CellStatus.UpDown
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Up)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Down)
                DrawHead(g, CellRect)
            Case CellStatus.LeftUp
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Left)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Up)
                DrawHead(g, CellRect)
            Case CellStatus.LeftDown
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Left)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Down)
                DrawHead(g, CellRect)
            Case CellStatus.RightUp
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Right)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Up)
                DrawHead(g, CellRect)
            Case CellStatus.RightDown
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Right)
                DrawMyLine(g, MyPen, CellRect, DrawStatus.Down)
                DrawHead(g, CellRect)
        End Select
    End Sub

    Private Sub DrawMyLine(ByVal myg As Graphics, ByVal myp As Pen, ByVal myr As Rectangle, ByVal ds As DrawStatus)
        Dim haba As Integer = myr.Width
        Dim hanba As Integer = Math.Round(haba / 2)
        Dim bit As Integer = Math.Round(myp.Width / 2)

        Select Case ds
            Case DrawStatus.Left
                myg.DrawLine(myp, myr.X, myr.Y + hanba, myr.X + hanba + bit, myr.Y + hanba)
            Case DrawStatus.Right
                myg.DrawLine(myp, myr.X + hanba - bit, myr.Y + hanba, myr.X + haba, myr.Y + hanba)
            Case DrawStatus.Up
                myg.DrawLine(myp, myr.X + hanba, myr.Y, myr.X + hanba, myr.Y + hanba + bit)
            Case DrawStatus.Down
                myg.DrawLine(myp, myr.X + hanba, myr.Y + hanba - bit, myr.X + hanba, myr.Y + haba)
        End Select
    End Sub

    Private Sub DrawHead(ByVal myg As Graphics, ByVal myr As Rectangle)
        Dim eye As Integer = 5

        If IamHead Then
            Select Case HeadPos
                Case Houkou.Up
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + CInt(Math.Round(myr.Width / 2 + 6 - eye / 2)), myr.Y + 4, eye, eye)
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + CInt(Math.Round(myr.Width / 2 - 6 - eye / 2)), myr.Y + 4, eye, eye)
                Case Houkou.Down
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + CInt(Math.Round(myr.Width / 2 + 6 - eye / 2)), myr.Y + myr.Height - 4 - eye, eye, eye)
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + CInt(Math.Round(myr.Width / 2 - 6 - eye / 2)), myr.Y + myr.Height - 4 - eye, eye, eye)
                Case Houkou.Left
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + 4, myr.Y + CInt(Math.Round(myr.Height / 2 + 6 - eye / 2)), eye, eye)
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + 4, myr.Y + CInt(Math.Round(myr.Height / 2 - 6 - eye / 2)), eye, eye)
                Case Houkou.Right
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + myr.Width - 4 - eye, myr.Y + CInt(Math.Round(myr.Height / 2 + 6 - eye / 2)), eye, eye)
                    myg.FillEllipse(Brushes.SaddleBrown, myr.X + myr.Width - 4 - eye, myr.Y + CInt(Math.Round(myr.Height / 2 - 6 - eye / 2)), eye, eye)
            End Select
        End If
    End Sub
End Class