﻿Public Class Form1
    Dim Grid As ReverseGrid
    Dim Make As Making
    Dim OKflag As Boolean = False

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Grid = New ReverseGrid(4, PictureBox1.Width)
        Make = New Making(Grid)
        Make.DoNothing()
        Make.ShowMaked()
        PictureBox1.Width = Grid.CellSize * Grid.Count + 2
        PictureBox1.Height = Grid.CellSize * Grid.Count + 2
        PictureBox1.Invalidate()
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        Grid.Draw(e.Graphics)
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If OKflag = True Then
            Dim Pos As Point = PictureBox1.PointToClient(Windows.Forms.Cursor.Position)
            Dim MyPos As Point = Grid.CellFromPoint(Pos.X, Pos.Y).Position

            MoveCell(MyPos.X, MyPos.Y)
            PictureBox1.Invalidate()
            lblCounter.Text += 1
            CheckClear()
        End If
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Make.Execution()
        Shuffle()
        lblCounter.Text = 0
        lblClear.Visible = False
        lblTY.Visible = False
        OKflag = True
        ClearSnake(False)
        CheckClear()
        PictureBox1.Invalidate()
    End Sub



    Private Function RandomN(ByVal minN As Integer, ByVal maxN As Integer) As Integer
        Randomize()
        RandomN = Fix(Rnd() * (maxN - minN + 1)) + minN
    End Function

    Private Sub MoveCell(ByVal xpos As Integer, ByVal ypos As Integer)
        If 0 <= xpos - 1 Then
            If Grid.Cells(xpos - 1, ypos).Status = CellStatus.Nothing Then
                Grid.Cells(xpos - 1, ypos).Status = Grid.Cells(xpos, ypos).Status
                Grid.Cells(xpos, ypos).Status = CellStatus.Nothing
                Exit Sub
            End If
        End If
        If 3 >= xpos + 1 Then
            If Grid.Cells(xpos + 1, ypos).Status = CellStatus.Nothing Then
                Grid.Cells(xpos + 1, ypos).Status = Grid.Cells(xpos, ypos).Status
                Grid.Cells(xpos, ypos).Status = CellStatus.Nothing
                Exit Sub
            End If
        End If
        If 0 <= ypos - 1 Then
            If Grid.Cells(xpos, ypos - 1).Status = CellStatus.Nothing Then
                Grid.Cells(xpos, ypos - 1).Status = Grid.Cells(xpos, ypos).Status
                Grid.Cells(xpos, ypos).Status = CellStatus.Nothing
                Exit Sub
            End If
        End If
        If 3 >= ypos + 1 Then
            If Grid.Cells(xpos, ypos + 1).Status = CellStatus.Nothing Then
                Grid.Cells(xpos, ypos + 1).Status = Grid.Cells(xpos, ypos).Status
                Grid.Cells(xpos, ypos).Status = CellStatus.Nothing
                Exit Sub
            End If
        End If
    End Sub

    Private Sub Shuffle()
        Dim k, kx, ky As Integer
        Dim nothingpoint, beforepoint As Point

        For ky = 0 To 3
            For kx = 0 To 3
                If Grid.Cells(kx, ky).Status = CellStatus.Nothing Then
                    nothingpoint = New Point(kx, ky)
                    beforepoint = New Point(kx, ky)
                End If
            Next
        Next
        k = 1000
        Do While k > 0
            RandoMove(nothingpoint, beforepoint, k)
        Loop
        SeiretuMove()
    End Sub

    Private Sub RandoMove(ByRef np As Point, ByRef bp As Point, ByRef kaisuu As Integer)
        Dim rndk As Integer = RandomN(1, 4)

        Select Case rndk
            Case 1
                If np.X + 1 <> bp.X And np.X + 1 <= 3 Then
                    MoveCell(np.X + 1, np.Y)
                    bp.X = np.X
                    bp.Y = np.Y
                    np.X += 1
                    kaisuu -= 1
                End If
            Case 2
                If np.X - 1 <> bp.X And np.X - 1 >= 0 Then
                    MoveCell(np.X - 1, np.Y)
                    bp.X = np.X
                    bp.Y = np.Y
                    np.X -= 1
                    kaisuu -= 1
                End If
            Case 3
                If np.Y + 1 <> bp.Y And np.Y + 1 <= 3 Then
                    MoveCell(np.X, np.Y + 1)
                    bp.X = np.X
                    bp.Y = np.Y
                    np.Y += 1
                    kaisuu -= 1
                End If
            Case 4
                If np.Y - 1 <> bp.Y And np.Y - 1 >= 0 Then
                    MoveCell(np.X, np.Y - 1)
                    bp.X = np.X
                    bp.Y = np.Y
                    np.Y -= 1
                    kaisuu -= 1
                End If
        End Select
    End Sub

    Private Sub SeiretuMove()
        Dim kx, ky As Integer

        For ky = 0 To 3
            For kx = 0 To 3
                MoveCell(kx, ky)
            Next
        Next
    End Sub

    Private Sub CheckClear()
        If Make.CheckClear = True Then
            lblClear.Visible = True
            lblTY.Visible = True
            OKflag = False
            ClearSnake(True)
        End If
    End Sub

    Private Sub ClearSnake(ByVal b As Boolean)
        PictureBox4.Visible = b
        PictureBox5.Visible = b
        PictureBox2.Visible = b
        PictureBox3.Visible = b
        lblKira1.Visible = b
        lblKira2.Visible = b
    End Sub

End Class
